local Speed = {
	Event = {},
	data = {
		playerID = "",
		update = false,
		enable = false,
		meter_x = 0,
		meter_y = 0,
		playerX =0,
		--playerY =0,
		playerZ =0,
		distance = 0,
		rate = 0,
	},
	 
}

local function unitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		Speed.data.enable = true
		end 
		end 
		end
		
local function unitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		Speed.data.enable = false
		end 
		end 
		end
		
		
local old = {x = 0, z = 0,}

local check = {one = 5, two = 5, three = 5, four = 5, five = 5,}

function Speed.Event.LoadEnd(handle, identifier)
	if identifier == "Speedometer" then
		Speed.data.playerID = Inspect.Unit.Lookup("player")
		
		print("Speedometer loaded. /Speed")
		
		firststamp()
	end
end


function firststamp()
now = Inspect.Time.Real()


end

	

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	Speed.data.meter_x = x - self.originalXDiff
	Speed.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)


box:SetPoint("CENTER",UIParent,"CENTER",100,100)
box:SetWidth(250)
box:SetHeight(40)
box:SetAlpha(.6)
box:SetVisible(true)
box:SetBackgroundColor(0,0,0)

ticker:SetText(" Speedometer Off ")
ticker:SetPoint("CENTER",box,"CENTER",0,0)
ticker:SetFontSize(25)


local lastCall = 0.0;
local change = 0.0;
AddDragFrame(box)



function SPEEDfade(handle)

if Speed.data.update and Speed.data.enable then
local now = Inspect.Time.Real()
	if (now<lastCall+.1) then 
		return
	end



if(Inspect.Unit.Detail(Speed.data.playerID).coordX)then
Speed.data.playerX = Inspect.Unit.Detail(Speed.data.playerID).coordX
--Speed.data.playerY = Inspect.Unit.Detail(Speed.data.playerID).coordY
Speed.data.playerZ = Inspect.Unit.Detail(Speed.data.playerID).coordZ
end

--local dx = old.x - Speed.data.playerX;
--local dy = old.y - Speed.data.playerY;
--local dz = old.z - Speed.data.playerZ;

local dx =  Speed.data.playerX - old.x;
--local dy = Speed.data.playerY - old.y ;
local dz =  Speed.data.playerZ - old.z;

--+ (dy * dy)
local rsqrd = (dx * dx)  + (dz * dz);
local r = math.sqrt(rsqrd); --distance change
change = r;
local age = now - lastCall; -- time since last inspect
--age = math.floor(age*10)/10
--local age = lastCall

check.five = check.four
check.four = check.three
check.three = check.two
check.two = check.one
check.one =(change / age)
Speed.data.rate = (check.one + check.two + check.three + check.four + check.five) / 5
Speed.data.rate = math.floor(Speed.data.rate * 10) / 10.0
--Speed.data.rate = math.floor((change / age)*10)
--Speed.data.rate = Speed.data.rate / 10


--1609.344 m = 1mi
ticker:SetText("Speed: "..Speed.data.rate)
--ticker:SetText(Speed.data.playerX.." : ".. Speed.data.playerY.." : ".. Speed.data.playerZ.."\nDistance: "..Speed.data.distance.."\nSpeed: "..Speed.data.rate.."\nage: " .. age)

Speed.data.distance = Speed.data.distance + change
old.x = Speed.data.playerX;
--old.y = Speed.data.playerY;
old.z = Speed.data.playerZ;

end



lastCall = Inspect.Time.Real()
end

local function Speedsave(handle)
 	 
SPEEDmeter_x = Speed.data.meter_x
SPEEDmeter_y = Speed.data.meter_y

   end


local function Speedload(handle)

if SPEEDmeter_x then
Speed.data.meter_x = tonumber(SPEEDmeter_x)
end

if SPEEDmeter_y then
 Speed.data.meter_y = tonumber(SPEEDmeter_y)
 end
 
box:ClearAll()
box:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Speed.data.meter_x, Speed.data.meter_y)
box:SetWidth(250)
box:SetHeight(40)
end 





  

function Speed.Event.SlashHandler(handle, str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")
		old.x = math.floor(Inspect.Unit.Detail(Speed.data.playerID).coordX)
		--old.y = math.floor(Inspect.Unit.Detail(Speed.data.playerID).coordY)
		old.z = math.floor(Inspect.Unit.Detail(Speed.data.playerID).coordZ)
		box:SetVisible(not Speed.data.update)
		ticker:SetVisible(not Speed.data.update)
		Speed.data.update = not Speed.data.update
		print("Speedometer Toggled")

	end   
   
Command.Event.Attach(Event.Unit.Availability.Full, unitAvailable, "unitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, unitNotAvailable, "unitNotAvailable")

Command.Event.Attach(Event.System.Update.Begin, SPEEDfade, "fade")

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, Speedsave, "Save variables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, Speedload, "Load variables")
Command.Event.Attach(Event.Addon.Load.End, Speed.Event.LoadEnd, "Init")
Command.Event.Attach(Command.Slash.Register("Speed"), Speed.Event.SlashHandler, "Slash")